@echo off
title Community Made Zuma Mod Batch File
:checkforcecho
IF EXIST "extras\batchprograms\cecho.exe" (
  goto menu
) ELSE (
  cls
  echo.
  echo   'extras\batchprograms\cecho.exe' could not be found.
  echo   The batch file requires this file in order to display properly.
  echo.
  echo   Alternatively, you can try CMZM_Batch_NCE.bat which does not use
  echo   said program.
  echo.
  echo   Press any key to exit.
  pause >nul
  exit
)
:menu
cls
REM --------------------------
REM ---
REM --- Main Menu
REM ---
REM --------------------------
color 0e
echo.
echo   COMMUNITY MADE ZUMA MOD
echo    Batch file created by CrushyGreenRen (version 1.1)
echo    Mod version is 1.1b
echo.
echo   This is a replacement to the launcher due to legal gray areas.
echo   This batch file, along with related data might be updated or replaced
echo   in the future.
echo.
extras\batchprograms\cecho {03}{\u0020}{\u0020}Join the Sphere Matchers Discord! A community for games like Zuma and Luxor{\n}
extras\batchprograms\cecho {03}{\u0020}{\u0020}{\u0020}https://discord.gg/gJgy5x5 {\n}
echo.
extras\batchprograms\cecho {0f}{\u0020}{\u0020}To navigate, press the corresponding key on your keyboard.{07}{\n}
echo.
echo    [1] Open Zuma Deluxe
echo    [2] Change difficulty
echo    [3] Change specific assets
echo    [4] Open readme file
echo    [5] List of links
echo    [6] Install thumbnails
CHOICE /C 123456 /N
IF %ERRORLEVEL% EQU 1 goto zuma
IF %ERRORLEVEL% EQU 2 goto levelfolderscan
IF %ERRORLEVEL% EQU 3 goto assetscan
IF %ERRORLEVEL% EQU 4 goto readme
IF %ERRORLEVEL% EQU 5 goto links
IF %ERRORLEVEL% EQU 6 goto thumbnailscan
REM --------------------------
REM ---
REM --- Links
REM ---
REM --------------------------
:links
cls
echo.
extras\batchprograms\cecho {0b}{\u0020}{\u0020}Links{07}{\n}
echo.
echo    [1] Sphere Matchers forum
echo    [2] Sphere Matchers Discord server
echo.
echo    [3] Forum thread
echo    [4] modworkshop.net mirror
echo    [5] Nexus Mods mirror
echo.
echo    [6] CMZM Discord
echo    [7] CMZM Steam Group
echo    [8] CMZM Steam Guide
echo.
echo    [B] Go back
CHOICE /C 12345678B /N
IF %ERRORLEVEL% EQU 1 goto smatchers
IF %ERRORLEVEL% EQU 2 goto sm_discord
IF %ERRORLEVEL% EQU 3 goto thread
IF %ERRORLEVEL% EQU 4 goto mws
IF %ERRORLEVEL% EQU 5 goto nexus
IF %ERRORLEVEL% EQU 6 goto discord
IF %ERRORLEVEL% EQU 7 goto group
IF %ERRORLEVEL% EQU 8 goto guide
IF %ERRORLEVEL% EQU 9 goto menu
:smatchers
rundll32 url.dll,FileProtocolHandler "http://spherematchers.boards.net"
goto menu
:sm_discord
rundll32 url.dll,FileProtocolHandler "https://discord.gg/gJgy5x5"
goto menu
:mws
rundll32 url.dll,FileProtocolHandler "http://modwork.shop/26159"
goto menu
:nexus
rundll32 url.dll,FileProtocolHandler "https://www.nexusmods.com/zumadeluxe/mods/1"
goto menu
:thread
rundll32 url.dll,FileProtocolHandler "http://spherematchers.boards.net/thread/12/zuma-deluxe-community-mod"
goto menu
:discord
rundll32 url.dll,FileProtocolHandler "https://discord.gg/2uMYbpZ"
goto menu
:group
rundll32 url.dll,FileProtocolHandler "https://steamcommunity.com/groups/communitymadezumamod"
goto menu
:guide
rundll32 url.dll,FileProtocolHandler "https://steamcommunity.com/sharedfiles/filedetails/?id=1929596236"
goto menu
REM --------------------------
REM ---
REM --- Readme
REM ---
REM --------------------------
:readme
IF EXIST "cmzm_readme.html" (
  cls
  cmzm_readme.html
  goto menu
) ELSE (
  cls
  echo.
  extras\batchprograms\cecho {0c}{\u0020}{\u0020}Readme file cannot be found!{07}{\n}
  echo.
  echo    Are you running this in the correct folder?
  echo    If so, is it named properly?
  echo.
  echo    Press any key to go back to the main menu.
  pause >nul
  goto menu
)
REM --------------------------
REM ---
REM --- Opening Zuma
REM ---
REM --------------------------
:zuma
IF EXIST "Zuma.exe" (
  cls
  color 07
  echo.
  echo   This window can now be safely closed.
  Zuma.exe
  exit
) ELSE (
  cls
  echo.
  extras\batchprograms\cecho {0c}{\u0020}{\u0020}Executable file cannot be found!{07}{\n}
  echo.
  echo    Are you running this in the correct folder?
  echo    If so, is it named 'zuma.exe'?
  echo.
  echo    Press any key to exit.
  pause >nul
  exit
)
REM --------------------------
REM ---
REM --- Difficulty Selector
REM ---
REM --------------------------
:levelfolderscan
cls 
REM --- Check if levels folder exists
echo.
extras\batchprograms\cecho {0b}{\u0020}{\u0020}Checking for levels folder...{07}{\n}
IF EXIST "levels" (
  goto xmlscan
) ELSE (
  cls
  echo.
  extras\batchprograms\cecho {0c}{\u0020}{\u0020}Levels folder cannot be found!{07}{\n}
  echo.
  echo    Are you running this in the correct folder?
  echo    If so, is it named properly?
  echo.
  echo    Press any key to exit.
  pause >nul
  exit
)
:xmlscan
cls
REM --- Check for levels.xml
echo.
extras\batchprograms\cecho {0b}{\u0020}{\u0020}Checking for levels.xml...{07}{\n}
IF EXIST "levels\levels.xml" (
  goto diffiscan
) ELSE (
  goto diffi_noxml
)
:diffiscan
cls
set difficulty=x
REM --- Easy
find "CMZM_EASY" levels\levels.xml
IF %ERRORLEVEL% EQU 0 set difficulty=e && goto diffi
REM --- Normal
find "CMZM_NORM" levels\levels.xml
IF %ERRORLEVEL% EQU 0 set difficulty=n && goto diffi
REM --- Hard
find "CMZM_HARD" levels\levels.xml
IF %ERRORLEVEL% EQU 0 set difficulty=h && goto diffi
REM --- Lunatic
find "CMZM_LUNA" levels\levels.xml
IF %ERRORLEVEL% EQU 0 set difficulty=l && goto diffi
:diffi_noxml
color 0c
set difficulty=x
echo.
echo    levels.xml was not found! You must select a difficulty.
echo    Press any key to go to the Difficulty Selector.
pause >nul
goto diffi
:diffi
cls
color 07
echo.
extras\batchprograms\cecho {0e}{\u0020}{\u0020}Difficulty Selector{\n}
echo.
IF %difficulty% EQU e extras\batchprograms\cecho {07}{\u0020}{\u0020}{\u0020}Current Difficulty: {0b}Easy{##}{\n}
IF %difficulty% EQU n extras\batchprograms\cecho {07}{\u0020}{\u0020}{\u0020}Current Difficulty: {0a}Normal{##}{\n}
IF %difficulty% EQU h extras\batchprograms\cecho {07}{\u0020}{\u0020}{\u0020}Current Difficulty: {0e}Hard{##}{\n}
IF %difficulty% EQU l extras\batchprograms\cecho {07}{\u0020}{\u0020}{\u0020}Current Difficulty: {0c}Lunatic{##}{\n}
IF %difficulty% EQU x extras\batchprograms\cecho {07}{\u0020}{\u0020}{\u0020}Current Difficulty: {08}Nothing{##}{\n}
echo.
echo    [E] Easy
extras\batchprograms\cecho {08}{\u0020}{\u0020}{\u0020}{\u0020}For new players and for those who just want it chill{##}{\n}
echo.
echo    [N] Normal
extras\batchprograms\cecho {08}{\u0020}{\u0020}{\u0020}{\u0020}For the casual players aiming for a challenge{##}{\n}
echo.
echo    [H] Hard
extras\batchprograms\cecho {08}{\u0020}{\u0020}{\u0020}{\u0020}Kicking the difficulty up{##}{\n}
echo.
echo    [L] Lunatic
extras\batchprograms\cecho {08}{\u0020}{\u0020}{\u0020}{\u0020}Do you dare?{##}{\n}
echo.
echo    [B] Go back
CHOICE /C ENHLB /N
IF %ERRORLEVEL% EQU 1 goto eas
IF %ERRORLEVEL% EQU 2 goto nor
IF %ERRORLEVEL% EQU 3 goto har
IF %ERRORLEVEL% EQU 4 goto lun
IF %ERRORLEVEL% EQU 5 goto menu
REM --------------------------
REM ---
REM --- Change to difficulties and open Zuma
REM ---
REM --------------------------
:eas
cls
copy /y extras\assets\xmls\levels\lvls-e.xml levels\levels.xml >nul
goto zuma
:nor
cls
copy /y extras\assets\xmls\levels\lvls-n.xml levels\levels.xml >nul
goto zuma
:har
cls
copy /y extras\assets\xmls\levels\lvls-h.xml levels\levels.xml >nul
goto zuma
:lun
cls
copy /y extras\assets\xmls\levels\lvls-l.xml levels\levels.xml >nul
goto zuma
REM --------------------------
REM ---
REM --- Scan if extra assets are installed
REM ---
REM --------------------------
:assetscan
color 0b
cls
echo.
echo   Scanning for assets folder
IF EXIST "extras\assets" (
  echo   Assets folder detected
  goto findexitfolder
) ELSE (
  goto noassets
)
:findexitfolder
IF EXIST "extras\assets\exits" (
  echo   Exits folder detected
  set _noexits=n
  goto findspheresetfolder
) ELSE (
  goto noexits
)
:findspheresetfolder
IF EXIST "extras\assets\spheresets" (
  echo   Sphere sets folder detected
  set _nospheresets=n
  goto assetmenu
) ELSE (
  goto nospheresets
)
REM --- No assets
:noassets
color 0c
echo.
echo   Assets folder was not found. Press any key to go back to the main menu.
pause >nul
goto menu
REM --- No exits
:noexits
set _noexits=y
goto findspheresetfolder
REM --- No spheresets
:nospheresets
set _nospheresets=y
goto assetmenu
REM
REM -- Exits
REM
:exitinit
color 07
echo Scanning for related files
goto findexittxt
:findexittxt
IF EXIST "extras\assets\exits\batsettings\CurrentExitSettings.txt" (
  echo Text file detected
  goto DetermineExit
) ELSE (
  goto CreateExitFile
)
:CreateExitFile
echo UNKNOWN > "extras\assets\exits\batsettings\CurrentExitSettings.txt"
goto DetermineExit
:DetermineExit
set _ExitAsset=x
REM --- Wormhole (Default)
find "WORMHOLE" extras\assets\exits\batsettings\CurrentExitSettings.txt
IF %ERRORLEVEL% EQU 0 set _ExitAsset=1 && goto exitselector
REM --- Stargate
find "STARGATE" extras\assets\exits\batsettings\CurrentExitSettings.txt
IF %ERRORLEVEL% EQU 0 set _ExitAsset=2 && goto exitselector
REM --- Unknown
find "UNKNOWN" extras\assets\exits\batsettings\CurrentExitSettings.txt
IF %ERRORLEVEL% EQU 0 set _ExitAsset=x && goto exitselector
REM 
REM --- Sphere Set Init
REM 
:spheresetinit
color 07
echo Scanning for related files
goto findsstxt
:findsstxt
IF EXIST "extras\assets\spheresets\batsettings\CurrentSpheresetSettings.txt" (
  echo Text file detected
  goto DetermineSphereset
) ELSE (
  goto CreateSpheresetFile
)
:CreateSpheresetFile
echo UNKNOWN > "extras\assets\spheresets\batsettings\CurrentSpheresetSettings.txt"
goto DetermineSphereset
:DetermineSphereset
set _Sphereset=x
REM --- Aqua Pearls
find "PEARLS" extras\assets\spheresets\batsettings\CurrentSpheresetSettings.txt
IF %ERRORLEVEL% EQU 0 set _Sphereset=1 && goto spheresetselector
REM --- Colorblind
find "COLORBLIND" extras\assets\spheresets\batsettings\CurrentSpheresetSettings.txt
IF %ERRORLEVEL% EQU 0 set _Sphereset=2 && goto spheresetselector
REM --- Unknown
find "UNKNOWN" extras\assets\spheresets\batsettings\CurrentSpheresetSettings.txt
IF %ERRORLEVEL% EQU 0 set _Sphereset=x && goto spheresetselector
REM --- Sphere Set Selector
:spheresetselector
cls
color 0e
echo.
echo   Sphere Set Selector
echo.
IF %_Sphereset% EQU 1 extras\batchprograms\cecho {07}{\u0020}{\u0020}{\u0020}Current Sphere Set: {0f}Aqua Pearls (Default){##}{\n}
IF %_Sphereset% EQU 2 extras\batchprograms\cecho {07}{\u0020}{\u0020}{\u0020}Current Sphere Set: {0f}Colorblind{##}{\n}
IF %_Sphereset% EQU x extras\batchprograms\cecho {07}{\u0020}{\u0020}{\u0020}Current Sphere Set: {0f}Unknown{##}{\n}
echo.
echo    [1] Aqua Pearls (Default)
echo    [2] Colorblind
echo.
echo    [B] Go back
echo    [V] Main menu
CHOICE /C 12BV /N
IF %ERRORLEVEL% EQU 1 goto SS_pearls
IF %ERRORLEVEL% EQU 2 goto SS_colorblind
IF %ERRORLEVEL% EQU 3 goto assetmenu
IF %ERRORLEVEL% EQU 4 goto menu
REM --- Sphereset changes
:SS_pearls
copy /y extras\assets\spheresets\default\*.gif images\
copy /y extras\assets\spheresets\default\resources.xml properties\resources.xml
echo PEARLS > extras\assets\spheresets\batsettings\CurrentSpheresetSettings.txt
goto zuma
:SS_colorblind
copy /y extras\assets\spheresets\colorblind\*.gif images\
copy /y extras\assets\spheresets\colorblind\resources.xml properties\resources.xml
echo COLORBLIND > extras\assets\spheresets\batsettings\CurrentSpheresetSettings.txt
goto zuma
REM --------------------------
REM ---
REM --- Exit selector
REM ---
REM --------------------------
:exitselector
cls
color 0e
echo.
echo   Exit Selector
echo.
IF %_ExitAsset% EQU 1 extras\batchprograms\cecho {07}{\u0020}{\u0020}{\u0020}Current Exit: {0f}Wormhole (Default){##}{\n}
IF %_ExitAsset% EQU 2 extras\batchprograms\cecho {07}{\u0020}{\u0020}{\u0020}Current Exit: {0f}Stargate{##}{\n}
IF %_ExitAsset% EQU x extras\batchprograms\cecho {07}{\u0020}{\u0020}{\u0020}Current Exit: {0f}Unknown{##}{\n}
echo.
echo    [1] Wormhole (Default)
echo    [2] Stargate
echo.
echo    [B] Go back
echo    [V] Main menu
CHOICE /C 12BV /N
IF %ERRORLEVEL% EQU 1 goto EXIT_wormh
IF %ERRORLEVEL% EQU 2 goto EXIT_starg
IF %ERRORLEVEL% EQU 3 goto assetmenu
IF %ERRORLEVEL% EQU 4 goto menu
REM --- Exit changes
:EXIT_wormh
copy /y extras\assets\exits\wormhole\_pitcover.png images\_pitcover.png
copy /y extras\assets\exits\wormhole\pitcover.png images\pitcover.png
echo WORMHOLE > extras\assets\exits\batsettings\CurrentExitSettings.txt
goto zuma
:EXIT_starg
copy /y extras\assets\exits\stargate\_pitcover.png images\_pitcover.png
copy /y extras\assets\exits\stargate\pitcover.png images\pitcover.png
echo STARGATE > extras\assets\exits\batsettings\CurrentExitSettings.txt
goto zuma
REM --------------------------
REM ---
REM --- Assets Menu
REM ---
REM --------------------------
:assetmenu
cls
echo.
extras\batchprograms\cecho {0b}{\u0020}{\u0020}Asset Changer{07}{\n}
echo.
IF %_noexits% EQU y extras\batchprograms\cecho {08}{\u0020}{\u0020}{\u0020}[ ] Exits{##}{\n}
IF %_nospheresets% EQU y extras\batchprograms\cecho {08}{\u0020}{\u0020}{\u0020}[ ] Sphere Set{##}{\n}
IF %_noexits% EQU n extras\batchprograms\cecho {07}{\u0020}{\u0020}{\u0020}[1] Exits{##}{\n}
IF %_nospheresets% EQU n extras\batchprograms\cecho {07}{\u0020}{\u0020}{\u0020}[2] Sphere Set{##}{\n}
echo.
echo    [B] Go back
CHOICE /C 12B /N
IF %ERRORLEVEL% EQU 1 goto checkifexits
IF %ERRORLEVEL% EQU 2 goto checkifspheres
IF %ERRORLEVEL% EQU 3 goto menu
:checkifexits
IF %_noexits% EQU y goto assetmenubeep
IF %_noexits% EQU n goto exitinit
:checkifspheres
IF %_nospheresets% EQU y goto assetmenubeep
IF %_nospheresets% EQU n goto spheresetinit
:assetmenubeep
echo 
goto assetmenu
REM --------------------------
REM ---
REM --- Thumbnail Changer
REM ---
REM --------------------------
:thumbnailscan
color 0b
cls
echo.
echo    First, checking if assets\thumbnails exists...
echo.
IF EXIST "extras\assets\thumbnails" (
  echo Thumbnails folder detected
  goto mainthumbnailscan
) ELSE (
  goto nothumbnails
)
:nothumbnails
color 0c
echo Thumbnails folder was not found. Press any key to go back to the main menu.
pause >nul
goto menu
:mainthumbnailscan
color 0b
cls
echo.
extras\batchprograms\cecho {0b}{\u0020}{\u0020}Checking for cached_thumbnails outside game folder...{07}{\n}
echo.
IF EXIST "%ProgramData%\PopCap Games\Zuma\levels\cached_thumbnails" (
  echo   PopCap-DRM thumbnail location detected!
  set _PD-Zuma=y
  goto steamcheck
) ELSE (
  echo   PopCap-DRM thumbnail location not found!
  set _PD-Zuma=n
  goto steamcheck
)
:steamcheck
IF EXIST "%ProgramData%\Steam\Zuma\levels\cached_thumbnails" (
  echo Steam-DRM thumbnail location detected!
  set _Steam-Zuma=y
  goto installscreen
) ELSE (
  echo Steam-DRM thumbnail location not found!
  set _Steam-Zuma=n
  goto installscreen
)
color 0e
:installscreenbeep
echo 
goto installscreen
:installscreen
cls
echo.
extras\batchprograms\cecho {0b}{\u0020}{\u0020}Install CMZM Thumbnails{07}{\n}
echo.
IF %_PD-Zuma% EQU y extras\batchprograms\cecho {07}{\u0020}{\u0020}{\u0020}[1] popcapgame1.exe (ProgramData\PopCap Games\Zuma\levels\cached_thumbnails){##}{\n}
IF %_Steam-Zuma% EQU y extras\batchprograms\cecho {07}{\u0020}{\u0020}{\u0020}[2] Steam (ProgramData\Steam\Zuma\levels\cached_thumbnails){##}{\n}
IF %_PD-Zuma% EQU n extras\batchprograms\cecho {08}{\u0020}{\u0020}{\u0020}[ ] popcapgame1.exe level thumbnail folder not found{##}{\n}
IF %_Steam-Zuma% EQU n extras\batchprograms\cecho {08}{\u0020}{\u0020}{\u0020}[ ] Steam level thumbnail folder not found{##}{\n}
echo.
echo.   If you have the PopCap DRM (popcapgame1) version of Zuma Deluxe, select 1.
echo    If you installed the mod on a Steam copy, select 2.
echo.
echo    If you installed the mod on a copy that reads thumbnails from the game's
echo    levels folder, you do not need to use this.
echo.
echo    [B] Go back
CHOICE /C 12B /N
IF %ERRORLEVEL% EQU 1 goto popcapgame1tc
IF %ERRORLEVEL% EQU 2 goto steamtc
IF %ERRORLEVEL% EQU 3 goto menu
:popcapgame1tc
IF %_PD-Zuma% EQU y goto popcapgame1t
IF %_PD-Zuma% EQU n goto installscreenbeep
:steamtc
IF %_Steam-Zuma% EQU y goto steamt
IF %_Steam-Zuma% EQU n goto installscreenbeep
REM --- Installing Thumbnails
:popcapgame1t
cls
color 07
echo Copying thumbnail files to:
echo %ProgramData%\PopCap Games\Zuma\levels\cached_thumbnails
echo.
copy extras\assets\thumbnails\*.png "%ProgramData%\PopCap Games\Zuma\levels\cached_thumbnails" /y
goto menu
:steamt
cls
color 07
echo Copying thumbnail files to:
echo %ProgramData%\Steam\Zuma\levels\cached_thumbnails
echo.
copy extras\assets\thumbnails\*.png "%ProgramData%\Steam\Zuma\levels\cached_thumbnails" /y
goto menu